<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>Combining Automata</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070622;10410900">
	<META NAME="CHANGED" CONTENT="20070710;16372900">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Combining Automata</B></FONT></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#start"><U>Getting
Started</U></A><A HREF="#blocks"><BR></A><A HREF="#combine"><U>Combining
and Changing</U></A></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="start"></A>Getting
Started</H2>
<P STYLE="margin-bottom: 0in">The reader, if he or she hasn't
already, should read the tutorial about <A HREF="../createfa/fa.html">creating
a finite automaton</A>. It covers the basics of constructing an
automaton and describes how one is implemented in JFLAP. This section
specifically describes how one may combine two separate automata into
one automaton using the “Convert → Combine Automata” menu
option. Note that although the examples shown here are finite
automata, this menu tool is also available for other types of
automata, such as Mealy machines, Moore machines, pushdown automata,
and Turing machines, both single-tape and multi-tape. Also note that
one can only combine alike automaton types. One cannot, for example,
combine a finite automaton and a Turing machine.</P>
<P STYLE="margin-bottom: 0in">To get started, open JFLAP. Then,
either load the files <A HREF="combine1.jff">combine1.jff</A> and
<A HREF="combine2.jff">combine2.jff</A>, which represent the languages
a*b and a(ba)* respectively, or construct them in two separate JFLAP
windows. <I>Do not run JFLAP twice to do this,</I> as you will not be
able to combine the automata if you generate the screens through
separate instances of the JFLAP program. Instead, once one automaton
is up, either load the file of the other automaton or generate a new
window using the “File → New” option. When finished, you should
have two screens which resemble the screens below:</P>
<P ALIGN=CENTER><IMG SRC="images/screen1" NAME="Graphic1" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P ALIGN=CENTER><IMG SRC="images/screen2" NAME="Graphic2" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="combine"></A>
<FONT SIZE=5><B>Combining and Changing</B></FONT></H2>
<P STYLE="margin-bottom: 0in">Now, in one of the windows, click on
the “Convert → Combine Automata” menu option. You will be asked
to which other open automaton you wish to combine with. Select the
opposite automaton from the menu bar, if the opposite is not the
default (if only those two automata are open, it should be both the
default and the only option in the menu. Click OK, and the two
automata should be on the same screen together in a new window,
resembling the screen shown below. Note that while the final states
are still valid for both, the only start state is from the automaton
from whose screen you selected the menu option.</P>
<P ALIGN=CENTER><IMG SRC="images/combined" NAME="Graphic3" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P ALIGN=LEFT>One can now combine and manipulate the two automata as
you see fit. For example, in order to demonstrate the language
(a*b)+(a(ba)*), one can add another state, set it to be the start
state, and create transitions from it to “q0” and “q2'. This
example is shown below, and can be loaded <A HREF="combine3.jff">combine3.jff</A>.</P>
<P ALIGN=CENTER><IMG SRC="images/screen3" NAME="Graphic4" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P STYLE="margin-bottom: 0in"><B>This concludes our brief tutorial on
combining automata. Thanks for reading!</B></P>
</BODY>
</HTML>
